using System.ComponentModel;
using System.Xml.Serialization;

namespace EQIA.EQIDL
{
    [TypeConverter(typeof(SpellGemDrawTemplateConverter))]
    public partial class SpellGemDrawTemplate : Class
    {
        private string myHolder, myBackground, myHighlight;

        [XmlElement("Holder", IsNullable = false)]
        [NotifyParentProperty(true)]
        public string Holder { get { return myHolder; } set { myHolder = value; } }

        [XmlElement("Background", IsNullable = false)]
        [NotifyParentProperty(true)]
        public string Background { get { return myBackground; } set { myBackground = value; } }

        [XmlElement("Highlight", IsNullable = false)]
        [NotifyParentProperty(true)]
        public string Highlight { get { return myHighlight; } set { myHighlight = value; } }

        public SpellGemDrawTemplate()
            : this(null)
        {
        }

        public SpellGemDrawTemplate(EQInterface eqInterface)
            : base(eqInterface)
        {
        }

        protected override void SetProperties(object obj)
        {
            base.SetProperties(obj);

            SpellGemDrawTemplate temp_SpellGemDrawTemplate = obj as SpellGemDrawTemplate;
            if (temp_SpellGemDrawTemplate != null)
            {
                Holder = temp_SpellGemDrawTemplate.Holder;
                Background = temp_SpellGemDrawTemplate.Background;
                Highlight = temp_SpellGemDrawTemplate.Highlight;
            }
        }
    }

    public class SpellGemDrawTemplateConverter : ExpandableObjectConverter
    {
        public override object ConvertTo(ITypeDescriptorContext context, System.Globalization.CultureInfo culture, object value, System.Type destinationType)
        {
            return (destinationType == typeof(string)) ? string.Empty : base.ConvertTo(context, culture, value, destinationType);
        }
    }
}
